
/*
------- CHANGELOG --------------------------------------------------------------

	2007-09-15  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (META REFRESH): Allow direct redirection to the url
	specified in the meta-content attribute.
	(FRAME REDIRECTION): Allow direct redirection to the source specified in
	the only (there is only one) frame-src attribute.
	(URL REDIRECTION): Allow direct redirection to the last url that is
	embedded in another url.

	2007-09-17  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (META REFRESH): Replaced the `indexOf' with the `search'
	function since some links are treated case sensitive by the servers!?
	(skipRedirect): Added tmp variable for the same reason.
	(isURL): Added prev variable to backtrack to the previous url before
	unescaping it. There could be spaces or suchlike in the url which need
	to be escaped.

	2007-09-29  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (var anchors): Corrected the xpath-expression. Now it
	works as I want it to.

	2007-09-30  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (function isURL): Added a space to the regular
	expression. It gave a problem with the URI-regex when there where spaces
	present at the end of the url.
	* 12295.user.js (function isURL): More trouble with spaces. This time in
	the url. Using `escape' on the url and change the first `:' (from
	the scheme from `%3A' back to `:'.
	* 12295.user.js (META REFRESH): Added the function `getTarget' to
	quickly redirect to the end of a redirect-trail.
	``Hail Netscape!'' for cookies. Cookies have to be enabled though!
	(function isURL): Added another `unescape' to the thing.

	2007-10-4  Kim A. Brandt <kimabrandt@gmx.de>
	* 12295.user.js (function isURL): Checking the previous with the current
	unescaped url so the loop will stop if there is a natural `%' sign
	present.

------- COMMENTS ---------------------------------------------------------------

	<b>To enable cookies do the following:</b>

		Enter <a href="about:config">about:config</a> in the URL bar.
		Filter: network.cookie.cookieBehavior
		Set value:
			0 (All cookies are allowed.) or
			1 (Only cookies from the originating server are allowed.)

------- RESOURCES --------------------------------------------------------------

	URL redirection
	http://en.wikipedia.org/wiki/URL_redirection
*/

const URI = /^[a-z][a-z0-9+-.]*:((\/\/((([a-z0-9-._~!$&'()*+,;=:]|%[a-f0-9]{2})*@)?((\[((([a-f0-9]{1,4}:){6}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(::([a-f0-9]{1,4}:){5}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(([a-f0-9]{1,4})?::([a-f0-9]{1,4}:){4}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-f0-9]{1,4}:)?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){3}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,2})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:){2}([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,3})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,4})?[a-f0-9]{1,4})?::([a-f0-9]{1,4}:[a-f0-9]{1,4})|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|(((([a-f0-9]{1,4}:){1,5})?[a-f0-9]{1,4})?::[a-f0-9]{1,4})|(((([a-f0-9]{1,4}:){1,6})?[a-f0-9]{1,4})?::))\])|((([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-._~!$&'()*+,;=]|%[a-f0-9]{2})*)(:[0-9]+)?)(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)|(\/(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)?)|(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*))(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;
const ABS_PATH = /^(\/(([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*)?)(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;
const REL_PATH = /^((([a-z0-9-._~!$&'()*+,;=:@]+|%[a-f0-9]{2})+(\/([a-z0-9-._~!$&'()*+,;=:@]*|%[a-f0-9]{2})*)*))(\?([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-._~!$&'()*+,;=:@/?]|%[a-f0-9]{2})*)?$/i;

function main()
{
	// META REFRESH
	var metas = document.evaluate("./html/head/meta[translate(@http-equiv,'EFHRS','efhrs')='refresh' and contains(translate(@content,'LUR','lur'),'url=')]", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (metas && metas.snapshotLength > 0)
	{
		var content = metas.snapshotItem(0).getAttribute("content");
		var index = content.search(/url=/i);
		var url = getURL(content.substring(index+4));
		var target = getTarget(window.location.href, url);
		if (locationReplace(target)) return;
		else window.addEventListener("load", function(){window.stop();}, false); // DOESN'T WORK WHEN GOING BACK IN HISTORY!
	}

	// FRAME REDIRECTION
	var frames = document.evaluate(".//frame[@src]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (frames && frames.snapshotLength == 1)
	{
		var url = getURL(frames.snapshotItem(0).src);
		if (locationReplace(url))return;
	}

	// URL REDIRECTION
	var anchors = document.evaluate(".//a[contains(translate(substring(@href,2),'HPT','hpt'),'http')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (anchors && anchors.snapshotLength > 0) for (var i = 0; i < anchors.snapshotLength; i++) skipRedirect(anchors.snapshotItem(i));
}

function skipRedirect(element)
{
	var href = element.getAttribute("href");
	var tmp = href.toLowerCase();
	var index = tmp.lastIndexOf("http");
	var url;
	do
	{
		if (index <= 0) return;
		if (url = isURL(href, index)) break;
	} while (index = tmp.lastIndexOf("http", index-1));
	if (index > 0) element.setAttribute("href", url); // SKIP REDIRECT
}

function isURL(href, index)
{
	var tmp = href.substring(index).match(/^[^?#&]+/);
	tmp = tmp[0];
	var prev;
	while (tmp.indexOf("%") > -1 && prev != tmp)
	{
		prev = tmp;
		tmp = unescape(tmp);
	}
	tmp = escape(tmp).replace(/%3A/, ":");
	var url = tmp.match(URI);
	if (url) return unescape(url[0]);
	return null;
}

function getURL(tmp)
{
	if (tmp.match(URI)) return tmp;
	var protocol = window.location.protocol;
	var host = window.location.host;
	if (tmp.match(ABS_PATH)) return protocol + "//" + host + tmp;
	else if (tmp.match(REL_PATH))
	{
		var pathname = window.location.pathname;
		pathname = pathname.substring(0, pathname.lastIndexOf("/")+1);
		return protocol + "//" + host + pathname + tmp;
	}
	return null;
}

function getTarget(loc, url)
{
	if (!loc || !url) return null;
	var value = readCookie(loc);
	var prev = url;
	if (value) while (value)
	{
		if (value == loc) return null; // WINDOW.STOP
		prev = value;
		value = readCookie(value);
	}
	else
	{
		createCookie(loc, url); // EXPIRE AT END OF SESSION
		return url;
	}
	return prev;
}

function locationReplace(url)
{
	if (!url) return false;
	window.location.replace(url);
	return true;
}

function createCookie(name,value,days)
{
	if (days)
	{
		var date = new Date();
		date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
		var expires = "; expires=" + date.toGMTString();
	}
	else var expires = "";
	document.cookie = name + "=" + value + expires + "; path=/"; // CREATE COOKIE
}

function readCookie(name)
{
	var nameEQ = name + "=";
	var ca = document.cookie.split(";");
	for(var i = 0; i < ca.length; i++)
	{
		var c = ca[i];
		while (c.charAt(0) == " ") c = c.substring(1, c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
	}
	return null;
}

/*function eraseCookies(name)
{
	var value = null;
	do
	{
		value = readCookie(name);
		createCookie(name, "", -1); // ERASE COOKIE
		name = value;
	} while (name);
}*/

main();
